#include <bits/stdc++.h>

using namespace std;

vector<vector<long long>> g;
vector<long long> used, tin, sz, c, t, d;
long long timer = 0, n;

void push(long long v, long long l, long long r) {
    long long m = (l + r) / 2;
    t[v * 2 + 1] += d[v] * (m - l);
    t[v * 2 + 2] += d[v] * (r - m);
    d[v * 2 + 1] += d[v];
    d[v * 2 + 2] += d[v];
    d[v] = 0;
}

void update(long long v, long long l, long long r, long long ql, long long qr, long long delta) {
    if (l >= qr || r <= ql) return;
    if (ql <= l && r <= qr) {
        t[v] += delta * (r - l);
        d[v] += delta;
        return;
    }
    long long m = (l + r) / 2;
    push(v, l, r);
    update(v * 2 + 1, l, m, ql, qr, delta);
    update(v * 2 + 2, m, r, ql, qr, delta);
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

long long get(long long v, long long l, long long r, long long ql, long long qr) {
    if (l >= qr || r <= ql) return 0;
    if (ql <= l && r <= qr) return t[v];
    long long m = (l + r) / 2;
    push(v, l, r);
    return get(v * 2 + 1, l, m, ql, qr) + get(v * 2 + 2, m, r, ql, qr);
}

void dfs(long long v) {
    used[v] = 1;
    sz[v] = 1;
    tin[v] = timer++;
    c.push_back(v);
    for (auto u : g[v]) {
        if (used[u] == -1) {
            dfs(u);
            sz[v] += sz[u];
        }
    }
}

void solve(long long pred, long long v, vector<long long>& a, vector<long long>& b) {
    long long max_num = 0;
    vector<long long> par;
    for (auto u : g[v]) {
        if (u != pred) {
            par.push_back(u);
            solve(v, u, a, b);
            max_num = max(max_num, a[u]);
        }
    }
    for (auto x : par) {
        long long now = max_num - a[x];
        update(0, 0, n, tin[x], tin[x] + sz[x], now);
        a[x] = 0;
        a[v] -= now;
    }
    b[v] += max_num;
    a[v] += max_num * par.size();
    if (pred != -1) {
        a[v] += max_num;
        a[pred] -= max_num;
    }
}

int main() {
    long long m; cin >> n >> m;
    g.resize(n);
    used.resize(n, -1);
    t.resize(n * 4, 0);
    d.resize(n * 4, 0);
    tin.resize(n, 0);
    sz.resize(n, 0);
    vector<long long> a(n), b(n, 0);
    for (long long i = 0; i < n; ++i) cin >> a[i];
    for (long long i = 0; i < m; ++i) {
        long long u, v; cin >> u >> v; u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0);
    solve(-1, 0, a, b);
    for (long long i = 0; i < n; ++i) {
        b[c[i]] += get(0, 0, n, i, i + 1);
    }
    for (long long i = 0; i < n; ++i) {
        if (a[i] < 0) {
             cout << "IMPOSSIBLE" << '\n';
             exit(0);
        }
    }
    cout << "Possible" << '\n';
    for (auto x : b) cout << x << ' ';
}
