#include "tunnels.h"
#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    for (int i = 0; i < n; i++) {
        int l = k, r = k;
        std::vector<int> good_r, good_l;
        for (int j = k; j < m; j++) {
            if (blocked[i][j]) {
                break;
            }
            if (i + 1 == n || !blocked[i + 1][j]) {
                r = j;
                good_r.push_back(j);
            }
        }
        for (int j = k; j >= 0; j--) {
            if (blocked[i][j]) {
                break;
            }
            if (i + 1 == n || !blocked[i + 1][j]) {
                l = j;
                good_l.push_back(j);
            }
        }
        bool left = false, right = false, was_l_r = false;
        if (l != k && r != k) {
        	was_l_r = true;
        	if (good_l[0] == k) {
            	left = investigate(good_l[1]);
        	} else {
        		left = investigate(good_l[0]);
        	}
            right = !left;
            //right = investigate(k + 1);
        } else if (l != k) {
            left = true; 
        } else if (r != k) {
            right = true;
        } else {
            goDeeper(k);
            continue;
        }
        if (left) {
            int ind = 0;
            if (good_l[0] == k && was_l_r) {
            	ind = 1;
            }
            long long l = ind, r = good_l.size();//was in l, not in r
            while (r - l > 1) {
            	long long mid = (l + r) / 2;
            	if (investigate(good_l[mid])) {
            		l = mid;
            	} else {
            		r = mid;
            	}
            }
            k = good_l[l];
            goDeeper(k);
            continue;
        }
        if (right) {
            int ind = 0;
            long long l = ind, r = good_r.size();//was in l, not in r
            while (r - l > 1) {
            	long long mid = (l + r) / 2;
            	if (investigate(good_r[mid])) {
            		l = mid;
            	} else {
            		r = mid;
            	}
            }
            k = good_r[l];
            goDeeper(k);
            continue;
        }
    }
}