#include "tunnels.h"
//#pragma once

#include <vector>

using namespace std;
void goDeeper(int s);
bool investigate(int s);
vector<vector<bool>> used, bl, can;
void dfs(int x, int y) {
    if (bl[x][y]) {
        throw(0);
    }
    used[x][y] = true;
    if (x + 1 == used.size()) {
        can[x][y] = true;
        return;
    }
    if (y + 1 < used[0].size() && !bl[x][y + 1]) {
        if (!used[x][y + 1]) {
            dfs(x, y + 1);
        }
        can[x][y] = can[x][y] || can[x][y + 1];
    }
    if (y - 1 >= 0 && !bl[x][y - 1]) {
        if (!used[x][y - 1]) {
            dfs(x, y - 1);
        }
        can[x][y] = can[x][y] || can[x][y - 1];
    }
    if (!bl[x + 1][y]) {
        if (!used[x + 1][y]) {
            dfs(x + 1, y);
        }
        can[x][y] = can[x][y] || can[x + 1][y];
    }
}
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    used.resize(n, vector<bool> (m));
    can.resize(n, vector<bool> (m));
    bl = blocked;
    dfs(0, k);
    used.assign(n, vector<bool> (m, false));
    dfs(0, k);
    for (int i = 0; i < n; i++) {
        int l = k, r = k;
        std::vector<int> good_r, good_l;
        for (int j = k; j < m; j++) {
            if (blocked[i][j]) {
                break;
            }
            if (i + 1 == n || (can[i + 1][j] && !blocked[i + 1][j])) {
                r = j;
                good_r.push_back(j);
            }
        }
        for (int j = k; j >= 0; j--) {
            if (blocked[i][j]) {
                break;
            }
            if (i + 1 == n || (can[i + 1][j] && !blocked[i + 1][j])) {
                l = j;
                good_l.push_back(j);
            }
        }
        bool left = false, right = false, was_l_r = false;
        if (l != k && r != k) {
            was_l_r = true;
            if (good_l[0] == k) {
                left = investigate(good_l[1]);
            } else {
                left = investigate(good_l[0]);
            }
            right = !left;
            //right = investigate(k + 1);
        } else if (l != k) {
            left = true; 
        } else if (r != k) {
            right = true;
        } else {
            goDeeper(k);
            continue;
        }
        if (left) {
            int ind = 0;
            if (good_l[0] == k && was_l_r) {
                ind = 1;
            }
            int l = ind, r = good_l.size();//was in l, not in r
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (investigate(good_l[mid])) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            k = good_l[l];
            goDeeper(k);
            continue;
        }
        if (right) {
            int ind = 0;
            int l = ind, r = good_r.size();//was in l, not in r
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (investigate(good_r[mid])) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            k = good_r[l];
            goDeeper(k);
            continue;
        }
    }
}