#include <bits/stdc++.h>
#include "tunnels.h"

#include <iostream>

static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

using namespace std;
int sp(int n, int m, int ind, vector <vector <bool>> v, int k) {
    vector <int> p;
    for (int i = k; i < m && v[ind][i] == 0; i++) {
        if (ind == n - 1 || v[ind + 1][i] == 0 || i == k) {
            p.push_back(i);
        }
    }
    for (int i = k - 1; i >= 0 && v[ind][i] == 0; i--) {
        if (ind == n - 1 || v[ind + 1][i] == 0) {
            p.push_back(i);
        }
    }
    sort(p.begin(), p.end());
    int d = -1, fl = 0;
    for (int i = 0; i < p.size(); i++) {
        if (p[i] == k) {
            d = i;
            if (ind != n - 1) fl = v[ind + 1][k];
        }
    }
    if (p.size() == 1) {
        goDeeper(p[0]);
        return p[0];
    }
    if ((p.size() == 2 && fl == 1)) {
        goDeeper(p[0] + p[1] - k);
        return p[0] + p[1] - k;
    }
    int c0 = d, c1 = p.size() - d - 1, l1 = 0;
    if (c0 >= c1) {
        if (c1 == 0) {
            l1 = 1;
        } else if (investigate(p[d - 1])) {
            l1 = 1;
        }
    } else {
        if (c0 == 0) {
            l1 = 0;
        } else if (investigate(p[d + 1])) {
            l1 = 0;
        } else {
            l1 = 1;
        }
    }
    if (l1 == 1) {
        int l = -1, r = d;
        if (c0 >= c1 && c1 != 0) {
            r--;
        } else if (fl) {
            r--;
        }
        while (r - l > 1) {
            int x = (r + l) / 2;
            if (investigate(p[x])) {
                r = x;
            } else {
                l = x;
            }
        }
        goDeeper(p[r]);
        return p[r];
    }
    int l = d, r = p.size();
    //cout << l << endl;
    if (c1 > c0 && c0 != 0) {
        l++;
    } else if (fl) {
        l++;
    }
    while (r - l > 1) {
        int x = (r + l) / 2;
        if (investigate(p[x])) {
            l = x;
        } else {
            r = x;
        }
    }
    goDeeper(p[l]);
    return p[l];
}
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& v) {
    for (int i = 0; i < n; i++) {
        k = sp(n, m, i, v, k);
    }
    return;
}
int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}

