#include <bits/stdc++.h>
#include "tunnels.h"

#include <iostream>

static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

using namespace std;
int sp(int n, int m, int ind, vector <vector <bool>> v, int k) {
    vector <int> p;
    for (int i = k; i < m && v[ind][i] == 0; i++) {
        if (ind == n - 1 || v[ind + 1][i] == 0 && i != k) {
            p.push_back(i);
        }
    }
    for (int i = k - 1; i >= 0 && v[ind][i] == 0; i--) {
        if (ind == n - 1 || v[ind + 1][i] == 0) {
            p.push_back(i);
        }
    }
    sort(p.begin(), p.end());
    if (p.size() == 1) {
        goDeeper(p[0]);
        return p[0];
    }
    int l = 0, r = p.size();
    //cout << l << endl;
    while (r - l > 1) {
        int x = (r + l) / 2;
        if (investigate(p[x])) {
            if (p[x] < k) {
                r = x;
            } else {
                l = x;
            }
        } else {
            if (p[x] < k) {
                l = x;
            } else {
                r = x;
            }
        }
    }
    if (p[l] > k) {
        goDeeper(p[l]);
        return p[l];
    } else if (r != p.size() && p[r] < k) {
        goDeeper(p[r]);
        return p[r];
    } else {
        goDeeper(k);
        return k;
    }

}
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& v) {
    for (int i = 0; i < n; i++) {
        k = sp(n, m, i, v, k);
    }
    return;
}
int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}

