#include <stdio.h>
#include <numeric>

using ll = long long;
const int BULAN = 35;

ll lcm[BULAN + 1];

const int MAX_NUM = 1024 * 1024;

int ciur[MAX_NUM + 1];

void brut(int a, int b) {
  for(int i = 1; i <= MAX_NUM; i++) {
    for(int j = i; j <= MAX_NUM; j += i) {
      ciur[j]++;
    }
  }

  int max = -1;
  int num = -1;
  for(int i = a; i <= b; i++) {
    if(ciur[i] > max) {
      max = ciur[i];
      num = i;
    }
  }

  printf("%d\n", num);
}

ll solve(ll a, ll b) {
  int st = 1;
  int dr = BULAN + 1;
  while(dr - st > 1) {
    int mij = (st + dr) / 2;
    if(lcm[mij] <= b) {
      st = mij;
    } else {
      dr = mij;
    }
  }

  ll x = lcm[st];
  if(x >= a) {
    return x;
  } else {
    return x * solve(a / x, b / x);
  }
}

int main() {
  ll a, b;
  scanf("%lld%lld", &a, &b);
  if(b <= (1 << 20)) {
    brut(a, b);
  } else {
    ll res = solve(a, b);
    printf("%lld\n", res);
  }

  return 0;
}