#include <stdio.h>
#include <numeric>
#include <ctype.h>

using ll = __int128;
const int BULAN = 35;

ll lcm[BULAN + 1];

const int MAX_NUM = 1024 * 1024;

int ciur[MAX_NUM + 1];

void brut(int a, int b) {
  for(int i = 1; i <= MAX_NUM; i++) {
    for(int j = i; j <= MAX_NUM; j += i) {
      ciur[j]++;
    }
  }

  int max = -1;
  int num = -1;
  for(int i = a; i <= b; i++) {
    if(ciur[i] > max) {
      max = ciur[i];
      num = i;
    }
  }

  printf("%d\n", num);
}

ll solve(ll a, ll b) {
  int st = 1;
  int dr = BULAN + 1;
  while(dr - st > 1) {
    int mij = (st + dr) / 2;
    if(lcm[mij] <= b) {
      st = mij;
    } else {
      dr = mij;
    }
  }

  ll x = lcm[st];
  if(x >= a) {
    return x;
  } else {
    return x * solve(a / x, b / x);
  }
}

ll read_big() {
  char ch;
  while(isspace(ch = fgetc(stdin)));
  ll ret = 0;
  do {
    ret = ret * 10 + ch - '0';
  } while(isdigit(ch = fgetc(stdin)));
  return ret;
}

void write_big(ll x) {
  if(x > 0) {
    write_big(x / 10);
    fputc(x % 10 + '0', stdout);
  }
}

int main() {
  ll a = read_big();
  ll b = read_big();
  if(b <= (1 << 20)) {
    brut(a, b);
  } else {
    lcm[0] = 1;
    for(int i = 1; i <= BULAN; i++) {
      lcm[i] = std::lcm(lcm[i - 1], i);
    }
    ll res = solve(a, b);
    write_big(res);
    fputc('\n', stdout);
  }

  return 0;
}