/*
operatie pe toate nodurile mai putin un nod
=> operatie inversa
*/
#include <stdio.h>
#include <vector>

const int MAX_N = 100'000;
const int ROOT = 0;
using ll = long long;

int n;
ll all;
ll minus[MAX_N];
int c[MAX_N];
ll w[MAX_N];
std::vector<int> adj[MAX_N];
ll cnt_subarb[MAX_N][2];
ll cnt[MAX_N][2];

ll dfs(int u, int prev) {
  ll ret = 0;
  for(int v : adj[u]) {
    if(v != prev) {
      ret += dfs(v, u);
    }
  }
  if(u != ROOT) {
    ret += c[u];
    if(ret < 0) {
      cnt[u][0] += -ret;
      cnt_subarb[u][0] += -ret;
    } else {
      cnt[u][1] += ret;
      cnt_subarb[u][1] += ret;
    }
  }
  return ret;
}

void dfs2(int u, int prev, ll sum1, ll sum2) {
  w[u] += sum1;
  all += sum2;
  minus[u] += sum2;
  sum1 += cnt_subarb[u][0];
  sum2 += cnt_subarb[u][1];
  for(int v : adj[u]) {
    if(v != prev) {
      dfs2(v, u, sum1, sum2);
    }
  }
}

int main() {
  int m;
  scanf("%d%d", &n, &m);
  ll sum = 0;
  for(int i = 0; i < n; i++) {
    scanf("%d", &c[i]);
    sum += c[i];
  }

  if(sum < 0) {
    printf("Impossible\n");
    return 0;
  } else {
    printf("Possible\n");
  }

  for(int i = 0; i < m; i++) {
    int u, v;
    scanf("%d%d", &u, &v);
    adj[u - 1].push_back(v - 1);
    adj[v - 1].push_back(u - 1);
  }

  dfs(ROOT, -1);

  for(int i = 0; i < n; i++) {
    w[i] += cnt[i][0];
    all += cnt[i][1];
    minus[i] += cnt[i][1];
  }

  dfs2(ROOT, -1, 0LL, 0LL);

  for(int i = 0; i < n; i++) {
    w[i] = w[i] + all - minus[i];
    printf("%lld ", w[i]);
  }
  printf("\n");

  return 0;
}