#include "tunnels.h"

std::vector<std::vector<bool>> mat;

int find_left(int m, int level, int pos) {
  while(pos >= 0 && mat[level][pos] == 0) {
    pos--;
  }
  return pos;
}

int find_right(int m, int level, int pos) {
  while(pos < m && mat[level][pos] == 0) {
    pos++;
  }
  return pos;
}

void solve(int n, int m, int k,
    const std::vector<std::vector<bool>>& blocked) {
  mat = blocked;
  int pos = k;
  for(int level = 0; level < n; level++) {
    int l = find_left(m, level, pos) + 1;
    int r = find_right(m, level, pos) - 1;
    if(l == pos && r == pos) {
      goDeeper(pos);
    } else if(l == pos) {
      int st = pos;
      int dr = m;
      while(dr - st > 1) {
        int mij = (st + dr) / 2;
        if(investigate(mij)) {
          st = mij;
        } else {
          dr = mij;
        }
      }
      pos = st;
      goDeeper(pos);
    } else if(r == pos) {
      int st = -1;
      int dr = pos;
      while(dr - st > 1) {
        int mij = (st + dr) / 2;
        if(investigate(mij)) {
          dr = mij;
        } else {
          st = mij;
        }
      }
      pos = dr;
      goDeeper(pos);
    } else {
      int ans1 = investigate(pos - 1);
      int ans2 = investigate(pos + 1);
      if(ans1 == 1 && ans2 == 1) {
        goDeeper(pos);
      } else if(ans1 == 1) {
        int st = pos;
        int dr = m;
        while(dr - st > 1) {
          int mij = (st + dr) / 2;
          if(investigate(mij)) {
            st = mij;
          } else {
            dr = mij;
          }
        }
        pos = st;
        goDeeper(pos);
      } else {
        int st = -1;
        int dr = pos;
        while(dr - st > 1) {
          int mij = (st + dr) / 2;
          if(investigate(mij)) {
            dr = mij;
          } else {
            st = mij;
          }
        }
        pos = dr;
        goDeeper(pos);
      }
    }
  }
}