#include <stdio.h>
#include <vector>
#include <queue>
#include <cassert>
#define MAXN 400000

std::queue<int> q;
long long aint[256*1024*4];
long long dirty[256*1024*4];
int n2;
int euler[MAXN],t=0;

struct Node{
    int x,parent;
    int f=0,children=0;
    std::vector <int> edges;
    int l,r;
};

Node v[MAXN];

void dfs(int node, int parent){
    v[node].parent=parent;
    v[node].l=t;
    euler[t++]=node;
    v[node].f=1;
    for(auto x : v[node].edges){
        if(v[x].f==0){
            v[node].children++;
            dfs(x, node);
        }
    }
    v[node].r=t-1;
}

void clean(int node){
    assert (node<2*n2);
    if(dirty[node]){
        aint[node]+=dirty[node];
        if(node<n2){
            dirty[2*node]+=dirty[node];
            dirty[2*node+1]+=dirty[node];
        }
        dirty[node]=0;
    }
}

void update(int l, int r, int lq, int rq, int node, long long val){
    if(l>=lq&&r<=rq){
        dirty[node]+=val;
        assert (node<2*n2);
        return;
    }
    if((l+r)/2>=lq)
        update(l, (l+r)/2, lq, rq, node*2, val);
    if((l+r)/2+1<=rq)
        update((l+r)/2+1, r, lq, rq, node*2+1, val);
}

void cleanAll(){
    for(int i=1; i<n2; i++){
        aint[i*2]+=aint[i];
        aint[i*2+1]+=aint[i];
        clean(i);
        clean(2*i);
        clean(2*i+1);
    }
}

void solve(int node){
    if(v[node].x>0){
        update(1, n2, v[node].l+1, v[node].r+1, 1, -v[node].x);
        update(1, n2, 1, t, 1, v[node].x);
    }else if(v[node].x<0){
        update(1, n2, v[node].l+1, v[node].r+1, 1, -v[node].x);
    }
    v[v[node].parent].x+=v[node].x;
    v[v[node].parent].children--;
    if(v[v[node].parent].children==0)
        q.push(v[node].parent);
}

int main()
{
    int n,m,i,x,y,sum=0;
    scanf("%d%d", &n, &m);
    for(i=0; i<n; i++){
        scanf("%d", &v[i].x);
        sum+=v[i].x;
    }
    for(i=0; i<m; i++){
        scanf("%d%d", &x, &y);
        x--;y--;
        v[x].edges.push_back(y);
        v[y].edges.push_back(x);
    }
    if(sum<0){
        printf("Impossible");
        return 0;
    }
    n2=1;
    while(n2<=n)
        n2*=2;
    printf("Possible\n");
    dfs(0, -1);
    for(i=0; i<n; i++){
        if(v[i].children==0){
            q.push(i);
        }
    }
    while(!q.empty()&&q.front()!=0){
        solve(q.front());
        q.pop();
    }
    cleanAll();
    for(i=0; i<n; i++){
        printf("%lld ", aint[n2+i]);
    }
    return 0;
}
