#include <stdio.h>
#include <vector>
#include <queue>
#include <cassert>
#define MAXN 400000

int q[MAXN],tt=0;
long long aint[256*1024*4];
long long n2,n;
long long euler[MAXN],t=0;

struct Node{
    long long x,parent;
    long long f=0,children=0;
    std::vector <long long> edges;
    long long l,r;
};

Node v[MAXN];

void dfs(long long node, long long parent){
    v[node].parent=parent;
    v[node].l=t;
    euler[t++]=node;
    v[node].f=1;
    for(auto x : v[node].edges){
        if(v[x].f==0){
            v[node].children++;
            dfs(x, node);
        }
    }
    v[node].r=t-1;
}

void update(long long l, long long r, long long lq, long long rq, long long node, long long val){
    if(l>=lq&&r<=rq){
        aint[node]+=val;
        assert (node<2*n2);
        return;
    }
    if((l+r)/2>=lq)
        update(l, (l+r)/2, lq, rq, node*2, val);
    if((l+r)/2+1<=rq)
        update((l+r)/2+1, r, lq, rq, node*2+1, val);
}

void cleanAll(){
    for(long long i=1; i<n2; i++){
        aint[i*2]+=aint[i];
        aint[i*2+1]+=aint[i];
    }
}

void solve(long long node){
    if(v[node].x>0){
        update(1, n2, v[node].l+1, v[node].r+1, 1, -v[node].x);
        update(1, n2, 1, t, 1, v[node].x);
    }else if(v[node].x<0){
        update(1, n2, v[node].l+1, v[node].r+1, 1, -v[node].x);
    }
    v[v[node].parent].x+=v[node].x;
    v[v[node].parent].children--;
    if(v[v[node].parent].children==0)
        q[tt++]=v[node].parent;
}

int main()
{
    long long m,i,x,y,sum=0;
    scanf("%lld%lld", &n, &m);
    for(i=0; i<n; i++){
        scanf("%lld", &v[i].x);
        sum+=v[i].x;
    }
    for(i=0; i<m; i++){
        scanf("%lld%lld", &x, &y);
        x--;y--;
        v[x].edges.push_back(y);
        v[y].edges.push_back(x);
    }
    if(sum<0){
        printf("Impossible");
        return 0;
    }
    n2=1;
    while(n2<=n)
        n2*=2;
    printf("Possible\n");
    dfs(0, -1);
    for(i=0; i<n; i++){
        if(v[i].children==0){
            q[tt++]=i;
        }
    }
    i=0;
    while(q[i]!=0){
        solve(q[i]);
        i++;
    }
    cleanAll();
    for(i=0; i<n; i++){
        printf("%lld ", aint[n2+i]);
    }
    return 0;
}
