#include "tunnels.h"
#include <bits/stdc++.h>
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int l=0,u=k;
    while(l<n-1)
    {
        //std::cout<<-1<<std::endl;
        std::vector<int>left;
        std::vector<int>right;
        int t=u-1;
        while(t>=0 && !blocked[l][t])
        {
            if(!blocked[l+1][t])
            {
                left.push_back(t);
            }
            t--;
        }
        //std::cout<<0<<std::endl;
        t=u+1;
        while(t<m && !blocked[l][t])
        {
            if(!blocked[l+1][t])
            {
                right.push_back(t);
            }
            t++;
        }
        //std::cout<<1<<std::endl;
        int ind=u;
        for(int i=0; i<left.size(); i++)
        {
            if(investigate(left[i]))
            {
                ind=left[i];
            }
            else
            {
                break;
            }
        }
        if(ind==u)
        {
            int x=0;
            if(blocked[l+1][u])
            {
                x=1;
                ind=right[0];
            }
            for(int i=x; i<right.size(); i++)
            {
                if(investigate(right[i]))
                {
                    ind=right[i];
                }
                else
                {
                    break;
                }
            }
        }
        goDeeper(ind);
        l++;
    }
    int i,j;
    for(i=u+1;i<m;i++)
    {
        if(blocked[l][i])
        {
            break;
        }
    }
    for(j=u;j>=0;j--)
    {
        if(blocked[l][j])
        {
            break;
        }
    }
    i--;
    j++;
    //std::cout<<i<<' '<<j<<std::endl;
    if(i==u && j==u)goDeeper(u);
    else if(i==u)
    {
        i--;
        for(;i>=j;i--)
        {
            if(!investigate(i))
            {
                goDeeper(i+1);
            }
            else if(i==j)
            {
                goDeeper(i);
            }
        }
    }
    else if(j==u)
    {
        j++;
        for(;j<=i;j++)
        {
            if(!investigate(j))
            {
                goDeeper(j-1);
            }
            else if(j==i)
            {
                goDeeper(j);
            }
        }
    }
}
static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}
int main()
{
    input();
    currX = 0;
    currY = k;
    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }
    solve(n, m, k, blocked);
    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }
    std::cout << "Reached the treasure room." << std::endl;
    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
