#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 10;
long long segment[4 * MAXN + 10];

long long query(int idx, int l, int r, int ql, int qr) {
    if (qr < l || r < ql) return LLONG_MAX;
    if (ql <= l && r <= qr) return segment[idx];

    int m = (l + r) / 2;
    return min(query(2 * idx, l, m, ql, qr), query(2 * idx + 1, m + 1, r, ql, qr));
}

long long update(int idx, int l, int r, int pos, long long val) {
    if (pos < l || r < pos) return segment[idx];
    if (l == r) return segment[idx] = min(segment[idx], val);

    int m = (l + r) / 2;
    return segment[idx] = min(update(2 * idx, l, m, pos, val), update(2 * idx + 1, m + 1, r, pos, val));
}

vector <long long> primes{2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71};

long long compute_divisors(long long n) {
    long long ans = 1;

    for (long long x : primes) {
        if (n == 1) break;

        long long cnt = 1;

        while (n % x == 0) {
            n /= x;
            cnt++;
        }

        ans *= cnt;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (int i = 1; i <= 4 * MAXN; i++) {
        segment[i] = LLONG_MAX;
    }

    long long useless, bound;
    cin >> useless >> bound;

    vector <pair <long long, long long>> numbers{{1, 1}}; /// {num, divisors}

    for (long long p : primes) {
        update(1, 1, MAXN, compute_divisors(numbers.back().first * p), numbers.back().first * p);
    }

    while (numbers.back().first <= bound) {
        long long num = query(1, 1, MAXN, numbers.back().second + 1, MAXN);
        //cout << num << endl;

        numbers.push_back({num, compute_divisors(num)});

        for (long long p : primes) {
            update(1, 1, MAXN, compute_divisors(numbers.back().first * p), numbers.back().first * p);
            //cout << "Added: " << numbers.back().first * p << endl;

        }
    }

    while (numbers.back().first > bound) {
        numbers.pop_back();
    }

    cout << numbers.back().first << endl;
    return 0;

}
