#include <bits/stdc++.h>
using namespace std;

const long long MAXN = 1e5 + 10;
long long c[MAXN];
vector <long long> edges[MAXN];
long long parent[MAXN], depth[MAXN];

void dfs(long long u, long long v, long long cnt) {
    parent[v] = u;
    depth[v] = cnt;

    for (long long x : edges[v]) {
        if (x != u) dfs(v, x, cnt + 1);
    }
}

long long dp[MAXN][20];
bool v[MAXN][20];

long long f(long long u, long long bit) {
    if (bit == 0) return parent[u];
    if (v[u][bit]) return dp[u][bit];
    v[u][bit] = 1;

    return dp[u][bit] = f(f(u, bit - 1), bit - 1);
}

long long lca(long long u, long long v) {
    if (depth[u] > depth[v]) {
        swap(u, v);
    }

    if (depth[u] < depth[v]) {
        long long diff = depth[v] - depth[u];

        for (long long p = 19; p >= 0; p--) {
            if (diff & (1 << p)) u = f(u, p);
        }
    }

    if (u == v) return u;

    for (long long p = 19; p >= 0; p--) {
        if (f(u, p) != f(v, p)) {
            u = f(u, p);
            v = f(v, p);
        }
    }

    return parent[u];
}

long long tree_prefix[MAXN];

void do_event(long long u, long long v, long long cost) {
    long long l = lca(u, v);

    tree_prefix[u] += cost;
    tree_prefix[l] -= cost;

    tree_prefix[v] -= cost;
    tree_prefix[l] += cost;
}

long long value[MAXN];
long long w[MAXN];

long long dfs_prefix(long long u, long long v) {
    long long sum = tree_prefix[v];

    for (long long x : edges[v]) {
        if (x != u) sum += dfs_prefix(v, x);
    }

    return value[v] = sum;
}

void dfs_values(long long u, long long v, long long sum) {
    sum += value[v];
    w[v] = sum;

    for (long long x : edges[v]) {
        if (x != u) dfs_values(v, x, sum);
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    vector <pair <long long, long long>> costs;

    long long n, m, total = 0;
    cin >> n >> m;
    assert(m == n - 1);

    for (long long i = 1; i <= n; i++) {
        cin >> c[i];
        costs.push_back({c[i], i});

        total += c[i];
    }

    if (total < 0) {
        cout << "Impossible\n";
        return 0;
    }

    cout << "Possible";

    sort(costs.begin(), costs.end());

    vector <tuple <long long, long long, long long>> events;

    long long ptr = costs.size() - 1;

    for (long long i = 0; i < costs.size(); i++) {
        if (costs[i].first >= 0) continue;

        while (costs[i].first < 0) {
            long long val = min(-costs[i].first, costs[ptr].first);
            costs[i].first += val;
            costs[ptr].first -= val;

            events.push_back({costs[i].second, costs[ptr].second, val});

            if (costs[ptr].first == 0) ptr--;
        }
    }

    for (long long i = 1; i < n; i++) {
        long long u, v;
        cin >> u >> v;

        edges[u].push_back(v);
        edges[v].push_back(u);
    }

    dfs(1, 1, 0);

    for (auto [u, v, cost] : events) {
        do_event(u, v, cost);
    }

    dfs_prefix(1, 1);

    dfs_values(1, 1, 0);
    long long mn = INT_MAX;

    for (long long i = 1; i <= n; i++) {
        mn = min(mn, w[i]);
    }

    for (long long i = 1; i <= n; i++) {
        cout << w[i] - mn << ' ';
    }

    return 0;

}
