#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;

bool ask(int cell, int q) {
    if (q == cell) return 1;
    return investigate(q);
}

bool visited[5002][5002];
vector <vector <int>> matrix(5002);

void dfs(int n, int m, int x, int y, const vector <vector <bool>>& blocked) {
    if (min(x, y) < 0 || x > n || y >= m) return;
    if (x != n && blocked[x][y]) return;
    if (visited[x][y]) return;
    visited[x][y] = 1;

    if (x != n && (x + 1 == n || !blocked[x + 1][y])) matrix[x].push_back(y);

    dfs(n, m, x - 1, y, blocked);
    dfs(n, m, x, y - 1, blocked);
    dfs(n, m, x, y + 1, blocked);
}

void solve(int n, int m, int k, const vector <vector <bool>>& blocked) {
    vector <vector <int>> block(n);
    vector <int> not_blocked;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (blocked[i][j]) block[i].push_back(j);
        }
    }

    int cell = k;

    for (int i = 0; i < n; i++) {
        int ptr = cell;
        while (ptr > 0 && !blocked[i][ptr - 1]) {
            ptr--;
        }

        vector <int> available_cells = matrix[i];

        /**if (i + 1 == n || !blocked[i + 1][ptr]) available_cells.push_back(ptr);

        while (ptr + 1 < m && !blocked[i][ptr + 1]) {
            ptr++;
            if (i + 1 == n || !blocked[i + 1][ptr]) available_cells.push_back(ptr);
        }

        //cout << "Available cells: ";
        //for (int x : available_cells) cout << ' ' << x;
        //cout << endl;*/

        auto it = lower_bound(available_cells.begin(), available_cells.end(), cell);

        if (available_cells.size() == 1) {
            cell = available_cells.front();
            goDeeper(cell);
            continue;
        }

        if (it != available_cells.begin() && ask(cell, *(--it))) {
            int l = 0, r = (int) (it - available_cells.begin()) - 1, ans = *it;

            while (l <= r) {
                int m = (l + r) / 2;

                if (ask(cell, available_cells[m])) {
                    ans = available_cells[m];
                    r = m - 1;
                } else l = m + 1;
            }

            cell = ans;
            goDeeper(ans);
            continue;
        }

        int l = lower_bound(available_cells.begin(), available_cells.end(), cell) - available_cells.begin() + 1, r = available_cells.size() - 1, ans = cell;

        while (l <= r) {
            int m = (l + r) / 2;

            if (ask(cell, available_cells[m])) {
                ans = available_cells[m];
                l = m + 1;
            } else r = m - 1;
        }

        cell = ans;
        goDeeper(ans);
        continue;
    }
}
/**
5 5 1
10100
00100
01000
00000
11110
*/
