#include<bits/stdc++.h>
#include "tunnels.h"
using namespace std;

const int MAXN = 5007;
int pref[MAXN][MAXN], suf[MAXN][MAXN];
vector<int> allowed[MAXN];

int bs1(bool left, int i, int x)
{
    if(left)
    {
        int l = -1, r = allowed[i].size(), mid;
        while(l < r-1)
        {
            mid = (l+r)/2;
            if(allowed[i][mid] < x) l = mid;
            else r = mid;
        }
        return r;
    }
    else
    {
        int l = -1, r = allowed[i].size(), mid;
        while(l < r-1)
        {
            mid = (l+r)/2;
            if(allowed[i][mid] > x) r = mid;
            else l = mid;
        }
        return l;
    }
}

int bs(bool right, int i, int k)
{
    if(right)
    {
        int l = bs1(true, i, k)-1, r = bs1(false, i, k+suf[i][k])+1, mid;
        if(allowed[i][l+1] == k) l++;
        while(l < r-1)
        {
            mid = (l+r)/2;
            if(investigate(allowed[i][mid])) l = mid;
            else r = mid;
        }
        return allowed[i][l];
    }
    else
    {
        int l = bs1(true, i, k-pref[i][k])-1, r = bs1(false, i, k)+1, mid;
        if(allowed[i][r-1] == k) r--;
        while(l < r-1)
        {
            mid = (l+r)/2;
            if(investigate(allowed[i][mid])) r = mid;
            else l = mid;
        }
        return allowed[i][r];
    }
}

void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    for(int i = 0; i < n; i++)
    {
        if(blocked[i][0]) pref[i][0] = -1;
        else pref[i][0] = 0;
        for(int j = 1; j < m; j++)
        {
            if(blocked[i][j]) pref[i][j] = -1;
            else pref[i][j] = pref[i][j-1]+1;
        }
    }
    for(int i = 0; i < n; i++)
    {
        if(blocked[i][m-1]) suf[i][m-1] = -1;
        else suf[i][m-1] = 0;
        for(int j = m-2; j >= 0; j--)
        {
            if(blocked[i][j]) suf[i][j] = -1;
            else suf[i][j] = suf[i][j+1]+1;
        }
    }
    for(int i = 0; i < n-1; i++)
    {
        for(int j = 0; j < m; j++)
        {
            if(!blocked[i+1][j] && !blocked[i][j]) allowed[i].push_back(j);
        }
    }
    for(int j = 0; j < m; j++)
    {
        allowed[n-1].push_back(j);
    }
    int curr = k;
    for(int i = 0; i < n; i++)
    {
        if(pref[i][curr] == 0 && suf[i][curr] == 0)
        {
            goDeeper(curr);
            continue;
        }
        if(pref[i][curr] == 0)
        {
            int ans = bs(true, i, curr);
            goDeeper(ans);
            curr = ans;
            continue;
        }
        if(suf[i][curr] == 0)
        {
            int ans = bs(false, i, curr);
            goDeeper(ans);
            curr = ans;
            continue;
        }
        bool t;
        int f = bs1(false, i, curr-1);
        if(f <= curr-pref[i][curr]-1) t = false;
        else
        {
            int s = bs1(true, i, curr+1);
            if(s >= curr+suf[i][curr]+1) t = true;
            else t = investigate(curr-1);
        }
        if(t)
        {
            int ans = bs(false, i, curr);
            goDeeper(ans);
            curr = ans;
            continue;
        }
        else
        {
            int ans = bs(true, i, curr);
            goDeeper(ans);
            curr = ans;
            continue;
        }
    }
    return;
}
/*
5 6 3
001001
000001
000100
110111
000000
*/
