///#include "tunnels.h"

#include <bits/stdc++.h>
using namespace std;

int n, m, k;
std::vector<std::vector<bool>> blocked;

void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

int numQueries = 0;

int currX;
int currY;

void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            return ;
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        return ;
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        return ;
    }
}

const int N = 5000 + 11;
pair<int, int> reach[N][N];

/// za 21 tochki:
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            if(blocked[i][j])
            {
                continue;
            }
            reach[i][j] = {j, j};
            for(int k=j+1; k<=m; k++)
            {
                if(k == m || blocked[i][k])
                {
                    reach[i][j].second = k - 1;
                    break;
                }
            }
            for(int k=j-1; k>=-1; k--)
            {
                if(k == -1 || blocked[i][k])
                {
                    reach[i][j].first = k + 1;
                    break;
                }
            }

            cout<<"Coordinates: "<<i<<" "<<j<<": reach = {"<<reach[i][j].first<<", "<<reach[i][j].second<<"}\n";
        }
    }
    int cx = 0, cy = k;
    while(cx < n)
    {
        for(int i=reach[cx][cy].first; i<=reach[cx][cy].second; i ++){
            if(cx < n-1 && blocked[cx + 1][i]){
                continue;
            }
            if(investigate(i)){
                goDeeper(i);
                cx ++;
                cy = i;
                break;
            }
        }
    }
    goDeeper(cy);
}

/*

5 5 3
01001
11000
00011
10001
10010

*/

int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        return 0;
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        return 0;
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
